Subject: Re: A question about include/linux/socket.h

From: Sinan Akpolat <[email-masked]>
Date: Wed, 28 Aug 2013 17:35:58 +0300

28.8.2013 17:27 tarihinde, Ben Hutchings yazdı:
> On Wed, 2013-08-28 at 16:45 +0300, Sinan Akpolat wrote:
>> Hi,
>>
>> I am writing CAN bus userspace code and I get a compiler error stating
>> "sa_family_t is not defined" for "include/linux/can.h". sa_family_t is
>> defined in include/linux/socket.h but it is not carried to userspace
>> kernel headers.
>>
>>    When I searched about it I saw that a similar problem in
>> include/linux/netlink.h and include/linux/socket.h is fixed by the patch:
>>
>> https://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/commit/include?id=6602a4baf4d1a73cc4685a39ef859e1c5ddf654c.
> You probably want commit bcb949b8847655516ba499ca75cd8529f167e360, which
> fixed include/linux/can.h.
Yeah, that's the one. Thank you very much, I couldn't find it using cgit 
interface in git.kernel.org.
>
>> I also read about UAPI but I can't use newer kernels.
>>
>> I searched the kernel git repo but couldn't find a similar patch for
>> can.h. When you search for "sa_family_t" in include/linux directory you
>> can see it is used in more than 10 files and I guess none of those files
>> will compile since they won't be able to find typedef sa_family_t (just
>> like can.h).
>>
>> So my question is:
>> - Does anyone remember a patch fixing this issue?
>> - Should the typedef sa_family_t moved to userspace kernel headers? Or
>> should structs containing sa_family_t type variables moved away from
>> user space?
> No, sa_family_t is normally defined by the C library headers.  But
> kernel headers generally don't include those (for good reasons).  So
> kernel headers should instead define and use __kernel_sa_family_t, and
> that's what they do now (mostly).
>
> Ben.
Thanks for the info.
>
>> I have been using the file manually defining sa_family_t but I wanted to
>> ask. I am using kernel version 2.6.37 but I guess can.h file was
>> unchanged until 3.5.